[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

[PATCH] Implement wanna-build --read-only



With this flag, only --list, --export and --info can be used. The
lockfiles are not checked or created, and the database is opened in
read-only mode.
---
 bin/wanna-build |   31 +++++++++++++++++++++----------
 1 files changed, 21 insertions(+), 10 deletions(-)

diff --git a/bin/wanna-build b/bin/wanna-build
index 48b350f..a547d13 100755
--- a/bin/wanna-build
+++ b/bin/wanna-build
@@ -50,7 +50,7 @@ our ($verbose, $mail_logs, $list_order, $list_state,
     $category, %catval, %short_category,
     $short_date, $list_min_age, $dbbase, @curr_time,
     $build_priority, %new_vers, $binNMUver, %merge_srcvers, %merge_binsrc,
-    $lock_for_pid, $transactional);
+    $lock_for_pid, $transactional, $read_only);
 
 # global vars
 $ENV{'PATH'} = "/bin:/usr/bin:/usr/local/bin:/org/wanna-build/bin/";
@@ -62,6 +62,7 @@ $short_date = strftime("%m/%d/%y",@curr_time);
 $| = 1;
 $lock_for_pid = -1; # -1 means normal procedure
 $transactional = 0; # 0 means: work on main copy
+$read_only = 0; # 1 means: do not set or check lock, do never write
 
 # map program invocation names to operation modes
 my %prognames = ( "uploaded-build"  => "set-uploaded",
@@ -192,6 +193,7 @@ my %options =
 	 "start-transaction" => { mode => "start-transaction" },
 	 "commit-transaction" => { mode => "commit-transaction" },
 	 "transactional" => { flag => \$transactional },
+	 "read-only" => { flag => \$read_only },
 	 "manual-edit"  => { mode => "manual-edit" },
 	 "create-maintenance-lock" => { mode => "maintlock-create" },
 	 "remove-maintenance-lock" => { mode => "maintlock-remove" },
@@ -253,6 +255,11 @@ if ($verbose) {
 	print "wanna-build $version for $distribution on $conf::dbbase\n";
 }
 
+if ($read_only && !isin( $op_mode, qw(list export info))) {
+	warn "Invalid operation with --read-only. You can only use --list, --export or --info.\n";
+	exit 1;
+}
+
 if (!@ARGV && !isin( $op_mode, qw(list merge-quinn merge-partial-quinn import export
 				  merge-packages manual-edit maintlock-create lock-for unlock-for
 				  start-transaction commit-transaction
@@ -324,7 +331,9 @@ if ($op_mode eq "unlock-for") {
 	exit 0;
 }
 
-lock_db( $distribution );
+if (!$read_only) {
+	lock_db( $distribution );
+}
 
 if ($op_mode eq "start-transaction") {
 	copy ( db_filename_master( $distribution ), db_filename_transaction( $distribution ))
@@ -352,17 +361,19 @@ if ($op_mode eq "commit-transaction") {
 }
 
 END {
-	untie %db;
-	if ($lock_for_pid == -1) {
-		unlock_db( $distribution );
-	}
-	foreach (keys %conf::distributions) {
-		untie %{$otherdb{$_}} if tied(%{$otherdb{$_}});
-		unlock_db( $_ ) if $otherdb_lock{$_};
+	if (!$read_only) {
+		untie %db;
+		if ($lock_for_pid == -1) {
+			unlock_db( $distribution );
+		}
+		foreach (keys %conf::distributions) {
+			untie %{$otherdb{$_}} if tied(%{$otherdb{$_}});
+			unlock_db( $_ ) if $otherdb_lock{$_};
+		}
 	}
 }
 
-tie %db, 'MLDBM', db_filename( $distribution ), GDBM_WRCREAT, 0664
+tie %db, 'MLDBM', db_filename( $distribution ), $read_only ? GDBM_READER : GDBM_WRCREAT, 0664
 	or die "FATAL: Cannot open database\n";
 
 process();
-- 
1.6.3.3


Reply to: